#include <bits/stdc++.h>
#include <chrono>

#define N_MAX 8
#define K_MAX 5
#define MOD 1000000007

using namespace std;
using namespace std::chrono;

ofstream fout("date.out");


int get_dp_size(int N, int K) {
    int ret = K;
    for(int i = 2; i <= N; i++) {
        ret *= (K - 1);
    }
    return ret;
}

int dp[N_MAX + 5][K_MAX * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1) * (K_MAX - 1)];
vector <string> good_config;
string curr;
vector <int> G[500000];

void get_good_config(int p, int N, int K) {
    if(p == N) {
        good_config.push_back(curr);
        return;
    }

    for(int v = 1; v <= K; v++) {
        char c = '0' + v;
        if(p == 0 || (curr[p - 1] != c)) {
            curr.push_back(c);
            get_good_config(p + 1, N, K);
            curr.pop_back();
        }
    }
}

bool check(string a, string b) {
    for(int i = 0; i < a.size(); i++) {
        if(a[i] == b[i]) {
            return false;
        }
    }
    return true;
}

int get_res(int N, int K) {
    int ret = 0;

   // cout << N << " " << K << " STARTED\n";
    auto start_f = high_resolution_clock::now();

    curr.clear();
    good_config.clear();
    get_good_config(0, N, K);
   // if(N == 1 && K == 4)
    //for(auto it : good_config) {
     //   cout << it << "\n";
    //}

    int L = good_config.size();

    for(int i = 0; i < L; i++) {
        G[i].clear();
    }

    //cout << L << "\n";
    auto start = high_resolution_clock::now();
    for(int i = 0; i < L; i++) {
        for(int j = i + 1; j < L; j++) {
            if(check(good_config[i], good_config[j])) {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }


    auto stop = high_resolution_clock::now();
    auto duration = duration_cast<microseconds>(stop - start);
   // cout << 0 << " ENDED after " << duration.count() / 1000000. << "\n";
    for(int i = 0; i < L; i++) {
        dp[1][i] = 1;
    }

    //cout << G[0].size() << "\n";
    for(int i = 2; i <= N; i++) {
        auto start = high_resolution_clock::now();
       // cout << i << " STARTED" << "\n";
        for(int j = 0; j < L; j++) {
            dp[i][j] = 0;
            for(auto it : G[j]) {
                dp[i][j] = (dp[i][j] + dp[i - 1][it]) % MOD;
            }
        }
        auto stop = high_resolution_clock::now();
        auto duration = duration_cast<microseconds>(stop - start);
      //  cout << i << " ENDED after " << duration.count() / 1000000. << "\n";
    }

    for(int j = 0; j < L; j++) {
        ret = (ret + dp[N][j]) % MOD;
    }
    auto stop_f = high_resolution_clock::now();
    auto duration_f = duration_cast<microseconds>(stop_f - start_f);
   // cout << N << " " << K << " ENDED after " << duration_f.count() / 1000000. << "\n";
    return ret;
}

void solve(int N, int K) {
    int res = get_res(N, K);

    cout << res << "\n";
}


int main()
{
    int N, K;
    cin >> N >> K;
  //  auto start = high_resolution_clock::now();
    //for(int N = 1; N <= N_MAX; N++) {
      //  for(int K = 2; K <= K_MAX; K++) {
            //int N = 3, K = 4;
            solve(N, K);
            //auto stop = high_resolution_clock::now();
           // auto duration = duration_cast<microseconds>(stop - start);
            //cout << "EXECUTION TIME UNTIL NOW " << duration.count() / 1000000. << "\n\n";
        //}
    //}
    //solve(7, 5);
    return 0;
}
