#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cstring>

using namespace std;

int N;
string S;

bool test(string S, int K) {
    // assert(S.length() % K == 0);

    int pieces = S.length() / K;
    for (int i = 0; i < pieces / 2; ++i) {
        int found = strncmp(
            S.c_str() + i * K,
            S.c_str() + (pieces - 1 - i) * K,
            K
        );

        if (found != 0) {
            // cerr << K << ": Fail after " << i+1 << " attempts" << endl;
            return false;
        }
    }

    return true;
}

int main() {
    ios::sync_with_stdio(false);

    cin >> N;
    cin >> S;

    vector<int> Ks;
    for (int K = 1; K * K <= N; ++K) if (N % K == 0) {
        if (test(S, K)) {
            Ks.push_back(K);
        }

        if (test(S, N / K)) {
            Ks.push_back(N / K);
        }
    }

    // assert(!Ks.empty());
    cout << *min_element(Ks.begin(), Ks.end()) << endl;
}
